package model

import (
	"time"

	"go.mongodb.org/mongo-driver/bson/primitive"
)

type ShapeInfo struct {
	Id   primitive.ObjectID `bson:"id,omitempty" json:"id"`
	Name string             `bson:"name,omitempty" json:"name"`
}

// 表面工艺信息
type MeshComp struct {
	Id         string             `bson:"id,omitempty" json:"id"`
	Name       string             `bson:"name,omitempty" json:"name"`
	FabricName string             `bson:"fabricName,omitempty" json:"fabricName"`
	FabricId   primitive.ObjectID `bson:"fabricId,omitempty" json:"fabricId"`
	FinishName string             `bson:"finishName,omitempty" json:"finishName"`
	FinishUuid string             `bson:"finishUuid,omitempty" json:"finishUuid"`

	Shapes      []ShapeInfo `bson:"shapes,omitempty" json:"shapes"`
	FinishThumb string      `bson:"finishThumb,omitempty" json:"finishThumb"`
}

// 模型库
type ModelLib struct {
	Id         primitive.ObjectID   `bson:"_id,omitempty" json:"_id"`
	MatIds     []primitive.ObjectID `bson:"matIds,omitempty" json:"matIds"`
	Name       string               `bson:"name,omitempty" json:"name"`
	CusNum     string               `bson:"cusNum,omitempty" json:"cusNum"`
	Cover      string               `bson:"cover,omitempty" json:"cover"`
	Order      int32                `bson:"order,omitempty" json:"order"`
	DotQueen   string               `bson:"dotqueen,omitempty" json:"dotqueen"`
	Blend      string               `bson:"blend,omitempty" json:"blend"`
	Categories []string             `bson:"categories,omitempty" json:"categories"`
	CreateTime time.Time            `bson:"createTime,omitempty" json:"createTime"`
	UpdateTime time.Time            `bson:"updateTime,omitempty" json:"updateTime"`
	Comps      []MeshComp           `bson:"comps,omitempty" json:"comps"`
}

type MyCase struct {
	Id         primitive.ObjectID `bson:"_id,omitempty" json:"_id"`
	UserId     string             `bson:"userId,omitempty" json:"userId"`
	UserName   string             `bson:"userName,omitempty" json:"userName"`
	Name       string             `bson:"name,omitempty" json:"name"`
	CusNum     string             `bson:"cusNum,omitempty" json:"cusNum"`
	Cover      string             `bson:"cover,omitempty" json:"cover"`
	Order      int32              `bson:"order,omitempty" json:"order"`
	Blend      string             `bson:"blend,omitempty" json:"blend"`
	Categories []string           `bson:"categories,omitempty" json:"categories"`
	CreateTime time.Time          `bson:"createTime,omitempty" json:"createTime"`
	UpdateTime time.Time          `bson:"updateTime,omitempty" json:"updateTime"`
	Comps      []MeshComp         `bson:"comps,omitempty" json:"comps"`
}
