package model

import (
	"time"

	"go.mongodb.org/mongo-driver/bson/primitive"
)

// user简单信息
type UserSmaple struct {
	Id         primitive.ObjectID `bson:"_id,omitempty" json:"_id"`
	Name       string             `bson:"name,omitempty" json:"name"`
	Avatar     string             `bson:"avatar,omitempty" json:"avatar"`
	LoginName  string             `bson:"loginName,omitempty" json:"loginName"`
	City       string             `bson:"city,omitempty" json:"city"`
	Roles      []string           `bson:"roles,omitempty" json:"roles"`
	Saas       *Saas              `bson:"saas,omitempty" json:"saas"`
	AppSaas    map[string]*Saas   `bson:"appSaas,omitempty" json:"appSaas"`
	CreateTime time.Time          `bson:"createTime,omitempty" json:"createTime"`
	UpdateTime time.Time          `bson:"updateTime,omitempty" json:"updateTime"`
}

type Saas struct {
	Title  string
	Level  int32
	Status string //使用中
	Exp    time.Time
}

type User struct {
	Id        primitive.ObjectID `bson:"_id,omitempty" json:"_id,omitempty"`
	LoginName string             `bson:"loginName,omitempty" json:"loginName,omitempty"`
	Phone     string             `bson:"phone,omitempty" json:"phone"`

	Password   string    `bson:"password,omitempty" json:"password,omitempty"`
	Name       string    `bson:"name,omitempty" json:"name,omitempty"`
	Email      string    `bson:"email,omitempty" json:"email,omitempty"`
	Avatar     string    `bson:"avatar,omitempty" json:"avatar,omitempty"`
	CreateTime time.Time `bson:"createTime,omitempty" json:"createTime,omitempty"`
	UpdateTime time.Time `bson:"updateTime,omitempty" json:"updateTime,omitempty"`
	// 注册其他信息
	RegInfo   *RegInfo  `bson:"regInfo,omitempty" json:"regInfo,omitempty"`
	Saas      *Saas     `bson:"saas,omitempty" json:"saas,omitempty"`
	LastLogin time.Time `bson:"lastLogin,omitempty" json:"lastLogin,omitempty"`
	UserType  *int      `bson:"userType,omitempty" json:"userType,omitempty"` //用户类型 1 -个人 2-企业
}

type RegInfo struct {
	Key     string      `bson:"key,omitempty" json:"key,omitempty"`
	Payload interface{} `bson:"payload,omitempty" json:"payload,omitempty"`
}
